<template>
    <div>
        <div class="breadcrumbs">
            <router-link to="/main">{{$t('message.main')}}</router-link>
            <div class="circle"></div>
            <div>{{$t('message.calculate_cost')}}</div>
        </div>

        <form @submit.prevent="calculate" class="form calculator">
			<div class="block" style="padding-bottom: 0">
				<div class="block-title">{{$t('message.calculate_cost')}}</div>

				<div class="row">
                    <div class="full_width">
                        <div class="input_component">
                            <cities-input
                                :placeholder="$t('message.from_send')"
                                v-model="sendFrom"
                                :cities='cities'
                                @set-city="setCity($event, 'From')"
                                :class="{error:(has_errors && !sendFrom)}"
                            ></cities-input>
                        </div>

                        <div v-if="has_errors" class="error_label">
                            <template v-if="!sendFrom">{{$t('message.required')}}</template>
                        </div>
                    </div>

                    <div class="full_width">
                        <div class="input_component">
                            <cities-input
                                :placeholder="$t('message.to_send')"
                                v-model="sendTo"
                                :cities='cities'
                                @set-city="setCity($event, 'To')"
                                :class="{error:(has_errors && !sendTo)}"
                            ></cities-input>
                        </div>

                        <div v-if="has_errors" class="error_label">
                            <template v-if="!sendTo">{{$t('message.required')}}</template>
                        </div>
                    </div>
				</div>

				<div class="row">
<!--					<label>Габарити, см</label>-->
                    <div class="full_width">
                        <div class="input_component">
                            <input
                                type="text"
                                v-model="max_length"
                                @keypress="handleInt"
                                @keyup="hendleLength"
                                @keydown="handleMaxSizeLength"
                                :placeholder="$t('message.max_size_shrt')"
                                :class="{error: (length_limit_err || (has_errors && !max_length))}"
                            >
                            <div class="lbl">{{$t('message.max_size_shrt')}}</div>
                        </div>

                        <div
                            class="measurement">
                            {{$t('message.sm')}}
                        </div>
<!--                        <v-select-->
<!--                            :items="sizes"-->
<!--                            :placeholder="$t('message.size')"-->
<!--                            v-model="max_length"-->
<!--                        ></v-select>-->

                        <div v-if="has_errors" class="error_label">
                            <template v-if="!max_length">{{$t('message.required')}}</template>
                        </div>
                        <div v-if="length_limit_err" class="error_label">
                            {{$t('message.length_limit')}}
                        </div>
                    </div>
<!--						<select v-if="sizes.length > 0">-->
<!--							<option v-for="size in sizes">{{size.text}}</option>-->
<!--						</select>-->
<!--					<label>Вага, кг</label>-->
                    <div class="full_width">
						<div class="input_with_label">
                            <div class="input_component">
                                <input
                                    type="text"
                                    v-model="weight"
                                    @keypress="handleFloat"
                                    @keyup="handleWeight"
                                    @keydown="handleMaxWeightLength"
                                    :placeholder="$t('message.weigth_kg')"
                                    :class="{error: (weight_limit_err || (has_errors && !weight))}"
                                >
                                <div class="lbl">{{$t('message.weigth_kg')}}</div>
                            </div>
                        </div>

                        <div
                            class="measurement">
                            {{$t('message.kg')}}
                        </div>

                        <div v-if="has_errors" class="error_label">
                            <template v-if="!weight">{{$t('message.required')}}</template>
                        </div>
                        <div v-if="weight_limit_err" class="error_label">
                            {{$t('message.weight_limit_full')}}
                        </div>
                    </div>
<!--					<div>-->
<!--&lt;!&ndash;						<label>Типорозмір</label>&ndash;&gt;-->
<!--						<input type="text" placeholder="Типорозмір" disabled>-->
<!--					</div>-->
						<!--						<label>Оголош. вартість, грн</label>-->
<!--						<input type="text" v-model="announcedPrice" placeholder="Оголош. вартість, грн">-->
				</div>
			</div>

            <div class="block buttons calculator-buttons">
                <div class="row">
                    <button
                        class="shipping-calculator button calculate"
                        :disabled="state.loading || weight_limit_err"
                    >{{ state.loading ? 'Рахуємо…' : 'Розрахувати' }}</button>
                    <!--					<div v-if="shippingPrice !== null" style="text-transform: uppercase">Вартість доставки - {{shippingPrice}} грн</div>-->

                    <div class="create_package">
                        <div class="data">
                            <div class="amount">
                                <div class="col-title">{{$t('message.delivery_amount')}}</div>
                                <div class="value">{{price}} грн</div>
                            </div>

                            <div class="box">
                                <div class="col-title">{{$t('message.box_size')}}:</div>
                                <div class="value">{{box_size}}</div>
                            </div>
                        </div>

                        <button
                            class="button"
                            @click="createPackage"
                        >
                            <!--                            :disabled='must_calculate'-->
                            {{$t('message.create_parcel')}}
                        </button>
                    </div>
                </div>
            </div>
        </form>

<!--        <div class="last_calculations" v-if="calculations.length > 0">-->
<!--            <table>-->
<!--                <thead>-->
<!--                    <tr>-->
<!--                        <td>Звідки</td>-->
<!--                        <td>Куди</td>-->
<!--                        <td>Вартість, грн</td>-->
<!--                    </tr>-->
<!--                </thead>-->
<!--                <tbody>-->
<!--                    <tr v-for="delivery in calculations">-->
<!--                        <td>{{ delivery.sendFrom }}</td>-->
<!--                        <td>{{ delivery.sendTo }}</td>-->
<!--                        <td>{{ delivery.sum }}</td>-->
<!--                    </tr>-->
<!--                </tbody>-->
<!--            </table>-->
<!--        </div>-->
    </div>
</template>

<script>
    import axios from 'axios';
    import CitiesInput from "./DeliveryCalculator/CitiesInput";
    export default {
        name: "CalculatorComponent",
        components: {
          "cities-input": CitiesInput
        },
        data: () => {
            return {
                state: {
                    loading: false
                },
                basePrice: 25,
                sendFrom: '',
                sendTo: '',
                weight: '',
                sizes: [
                    {
                        text: 'до 40 см',
                        value: 40,
                    },
                    {
                        text: 'до 60 см',
                        value: 60,
                    },
                    {
                        text: 'до 90 см',
                        value: 90,
                    }
                ],
                announcedPrice: '',
                shippingPrice: null,
                selectedWeight: '',
                calculations: [],
                price: 0,
                box_size: '-',
                max_length: null,
                has_errors: false,
                from_city: {},
                to_city: {},
                length_limit_err: null,
                weight_limit_err: null
            };
        },
        methods: {
            async calculate() {
                this.has_errors = !this.validate().is_valid;
                if(this.has_errors) return;
                this.state.loading = true;
                const formData = {
                    from: this.from_city.uuid,
                    to: this.to_city.uuid,
                    max_length: this.max_length,
                    weight: this.weight,
                    payer: 'sender'
                };

                try{
                    const {data} = await axios.post('/order/calculate', formData);
                    this.price = parseInt(data.result.price);
                    this.box_size = data.result.size;
                } catch (e){
                    this.$store.commit('set_errors', {text: [e.response.data]});
                    this.$modal.show('error');
                }
                this.state.loading = false;
            },
            setCity(city, type){
                this[`send${type}`] = city;
                this[`${type.toLowerCase()}_city`] = city;
            },
            validate () {
                let is_valid = Boolean(this.sendFrom && this.sendTo && this.max_length && this.weight);
                let errors = {};
                return {
                    is_valid,
                    errors
                };
            },
            createPackage () {
                this.$store.dispatch('setPoints', {
                    to: this.to_city,
                    from: this.from_city,
                    max_length: this.max_length,
                    weight: this.weight
                });
                this.$router.push('/package/create');
            },
            is_allowed_float(n){
                return /^((\d+)|(\d+(\.|\,))|(\d+(\.|\,)\d+))$/.test(n);
            },
            handleFloat (e) {
                if (!this.is_allowed_float(e.target.value + e.key) && e.key) {
                    e.preventDefault();
                    return false;
                }
            },
            handleInt (e) {
                if(!(/[0-9]/.test(e.key)) && e.key)
                {
                    e.preventDefault();
                    return false;
                }
            },
            hendleLength (e) {

                this.length_limit_err = this.max_length > 90;
            },
            handleMaxLLength (e) {
                let max_length = 2;

                e.currentTarget.value = (e.currentTarget.value.length >= max_length )
                    ? e.currentTarget.value.slice(0,max_length-1)
                    : e.currentTarget.value;
            },
            handleMaxWLength (e) {
                let max_length = 6;

                // e.currentTarget.value = (e.currentTarget.value.length >= max_length && Number.isInteger(parseInt(e.key)))
                e.currentTarget.value = (e.currentTarget.value.length >= max_length )
                    ? e.currentTarget.value.slice(0,max_length-1)
                    : e.currentTarget.value;
            },
            handleWeight (e) {
                this.weight = this.weight.replace(',','.');
                this.weight_limit_err = this.weight > 90;
            },
            handleMaxWeightLength (e) {
                let allowed_key_code = [8,37,39,46,35];
                let max_length = 3;
                // let current_length = e.currentTarget.value.replace(new RegExp(/(\,|\.)/, 'g'),'').length;

                if(
                    (e.currentTarget.value.length >= max_length )
                    && !allowed_key_code.includes(e.keyCode)
                    && (e.currentTarget.selectionStart == e.currentTarget.selectionEnd)
                ) {

                    // this.$store.dispatch('setWeightError', this.$t('message.weight_limit_prefix') + this.to_department.weight_limit + this.$t('message.kg'));
                    this.$store.dispatch('setWeightError', this.$t('message.weight_limit_full'));
                    // this.has_errors = false;
                    // this.is_weight_valid = false;
                    e.preventDefault();
                } else {
                    // this.has_errors = true;
                }
            },
            handleMaxSizeLength (e) {
                let allowed_key_code = [8,37,39,46,35];
                let max_length = 2;
                if(
                    (e.currentTarget.value.length >= max_length )
                    && !allowed_key_code.includes(e.keyCode)
                    && (e.currentTarget.selectionStart == e.currentTarget.selectionEnd)
                ) {
                    // this.$store.dispatch('setLengthError', this.$t('message.length_limit'));
                    // this.length_limit_err = true;
                    e.preventDefault();
                }
            },
        },
        computed: {
            cities: function () {
                return this.$store.getters.cities;
            }
        },
        created() {
            this.$store.dispatch('setCities');
        }
    }
</script>
